
#include <stdio.h>
#include "i2c_gpio.h"

extern void print(char *ptr);
extern void itoa(unsigned long n, char *s);

/*
 * Reads bearing from an I2C Compass
 * Register [1] is bearing normalized to [0,254]
 * Register ([2] << 8) | [3] is bearing [0,359.9] * 10
 * 
 * Clock line is attached to pin SGPIO[7]
 * Data line is attached to pin SGPIO[6]
 *
 */

int main()
{
	unsigned char small, upper, lower;
	unsigned int full;
	unsigned long delaycount;
	char str[50];

	print("Starting...\n");
	i2c_init();
	print("Initialized.\n");

	while (1){
		small = i2c_get_register(0xc0, 1);
		upper = i2c_get_register(0xc0, 2);
		lower = i2c_get_register(0xc0, 3);
		full = (upper << 8) | lower;

		print("Small: ");
		itoa((unsigned int)small, str);
		print(str);
		print(" Full: ");
		itoa(full, str);
		print(str);
		print("\n");
		//printf("Small: %d, Full: %d\n", small, full);

		delaycount=0;
		do{
			delaycount++;
		}while(delaycount < 100000);
	}
}

