#ifndef _I2C_TPU_H_
#define _I2C_TPU_H_

#include <Motorola/m_common.h>
#include <Motorola/mpc555.h>
#include <Motorola/tpu_dio.h>
#include <Motorola/mpc500_util.h>

struct i2c_tpu_data {
	struct TPU3_tag *tpu;
	unsigned short clockpin;
	unsigned short datapin;
        unsigned short datastatus; //zero => input, nonzero => output
};

void i2c_set_data_high(struct i2c_tpu_data *tpu_data);
void i2c_set_data_low(struct i2c_tpu_data *tpu_data);
void i2c_set_clock_high(struct i2c_tpu_data *tpu_data);
void i2c_set_clock_low(struct i2c_tpu_data *tpu_data);
unsigned char i2c_get_data(struct i2c_tpu_data *tpu_data);
void i2c_set_data_output(struct i2c_tpu_data *tpu_data);
void i2c_set_data_input(struct i2c_tpu_data *tpu_data);
void i2c_set_clock_output(struct i2c_tpu_data *tpu_data);
void i2c_delay(void);
void i2c_start(struct i2c_tpu_data *tpu_data);
void i2c_init(struct i2c_tpu_data *tpu_data);
void i2c_stop(struct i2c_tpu_data *tpu_data);
void i2c_write(struct i2c_tpu_data *tpu_data, unsigned char output_data);
unsigned char i2c_read(struct i2c_tpu_data *tpu_data);
void i2c_wait_acknowledge(struct i2c_tpu_data *tpu_data);
void i2c_send_acknowledge(struct i2c_tpu_data *tpu_data, unsigned char ack_bit);
unsigned char i2c_get_register(struct i2c_tpu_data *tpu_data, unsigned char address, unsigned char reg);
unsigned char i2c_set_register(struct i2c_tpu_data *tpu_data, unsigned char address, unsigned char reg, unsigned char value);

#endif /* _I2C_TPU_H_ */

